; Compiled with: PIC Simulator IDE v6.91
; Microcontroller model: PIC16F630
; Clock frequency: 4.0 MHz
;
;       The address of 'x' (byte) (global) is 0x34
	x EQU 0x34
;       The address of 'change' (bit) (global) is 0x35,0
;       The address of 'strike' (byte) (global) is 0x36
	strike EQU 0x36
;       The address of 'xc' (byte) (global) is 0x37
	xc EQU 0x37
;       The address of 'fs' (bit) (global) is 0x35,1
;       The address of 'den_c' (byte) (global) is 0x38
	den_c EQU 0x38
;       The address of 'each' (byte) (global) is 0x39
	each EQU 0x39
;       The address of 'att' (bit) (global) is 0x35,2
;       The address of 'state' (bit) (global) is 0x35,3
;       The address of 'atc' (byte) (global) is 0x3A
	atc EQU 0x3A
;       The address of 'rcnt' (byte) (global) is 0x3B
	rcnt EQU 0x3B
;       The address of 'gcnt' (byte) (global) is 0x3C
	gcnt EQU 0x3C
;       The address of 'acs' (bit) (global) is 0x35,4
;       The address of 'wcode' (bit) (global) is 0x35,5
;       The address of 'rat' (bit) (global) is 0x35,6
;       The address of 'gat' (bit) (global) is 0x35,7
;       The address of 'denide' (bit) (global) is 0x3D,0
;       The address of 'code' (byte) (global) is 0x3E
	code EQU 0x3E
;       The address of 'apn' (byte) (global) is 0x3F
	apn EQU 0x3F
;       The address of 'scnt' (byte) (global) is 0x40
	scnt EQU 0x40
;       The address of 'spn' (byte) (global) is 0x41
	spn EQU 0x41
;       The address of 'acc' (byte) (global) is 0x42
	acc EQU 0x42
;       The address of 'first' (byte) (global) is 0x43
	first EQU 0x43
;       The address of 's' (bit) (global) is 0x3D,1
;       The address of 'den_p' (long) (global) is 0x44
	den_p EQU 0x44
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	LONG_0 EQU 0x2C
	LONG_1 EQU 0x2D
	LONG_2 EQU 0x2E
	LONG_3 EQU 0x2F
	LONG2_0 EQU 0x30
	LONG2_1 EQU 0x31
	LONG2_2 EQU 0x32
	LONG2_3 EQU 0x33
	W_TEMP EQU 0x5F
	STATUS_TEMP EQU 0x5E
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0004
	ORG 0x0004
	MOVWF W_TEMP
	SWAPF STATUS,W
	CLRF STATUS
	MOVWF STATUS_TEMP
	CALL L0005
	SWAPF STATUS_TEMP,W
	MOVWF STATUS
	SWAPF W_TEMP,F
	SWAPF W_TEMP,W
	RETFIE
; Begin of program
L0004:
; 1: '0123456789012345678901234567890123456789012345
; 2: 
; 3: 'PIC 16F630  
; 4: 
; 5: '  
; 6: OPTION_REG = %01000111
	MOVLW 0x47
	BSF STATUS,RP0
	MOVWF 0x01
	BCF STATUS,RP0
; 7: '   TMR0
; 8: INTCON = %10100000
	MOVLW 0xA0
	MOVWF 0x0B
; 9: '  
; 10: CMCON = %00000111
	MOVLW 0x07
	MOVWF 0x19
; 11: 
; 12: ' PORTA (/)
; 13: TRISA = %00111111
	MOVLW 0x3F
	BSF STATUS,RP0
	MOVWF 0x05
	BCF STATUS,RP0
; 14: ' PORT (/)
; 15: TRISC = %00110001
	MOVLW 0x31
	BSF STATUS,RP0
	MOVWF 0x07
	BCF STATUS,RP0
; 16: 
; 17: '  
; 18: Dim att As Bit
; 19: '  
; 20: Dim atc As Byte
; 21: '  
; 22: '   
; 23: Dim apn As Byte
; 24: 
; 25: '  
; 26: Dim rat As Bit
; 27: '  
; 28: ' 
; 29: Dim rcnt As Byte
; 30: 
; 31: '  
; 32: Dim gat As Bit
; 33: '  
; 34: ' 
; 35: Dim gcnt As Byte
; 36: 
; 37: ' 
; 38: ' /  
; 39: Dim scnt As Byte
; 40: '   
; 41: '   
; 42: Dim spn As Byte  'punish
; 43: 
; 44: '  
; 45: Dim x As Byte
; 46: '  
; 47: Dim xc As Byte
; 48: 
; 49: ' 
; 50: Dim acs As Bit
; 51: '    
; 52: Dim acc As Byte
; 53: 
; 54: '  
; 55: Dim wcode As Bit
; 56: '   
; 57: Dim state As Bit
; 58: ' 5
; 59: Dim each As Byte
; 60: '  5
; 61: Dim strike As Byte
; 62: 
; 63: '  
; 64: Dim s As Bit
; 65: '  
; 66: Dim change As Bit  'change password
; 67: change = 0
	BCF 0x35,0
; 68: 
; 69: '   
; 70: Dim first As Byte
; 71: '/ 
; 72: Dim fs As Bit
; 73: 
; 74: '  
; 75: Dim denide As Bit
; 76: denide = 0
	BCF 0x3D,0
; 77: '   
; 78: Dim den_c As Byte
; 79: den_c = 0
	CLRF 0x38
; 80: '  
; 81: Dim den_p As Long
; 82: den_p = 0
	CLRF 0x44
	CLRF 0x45
	CLRF 0x46
	CLRF 0x47
; 83: 
; 84: Gosub clear
	CALL L0001
; 85: 
; 86: ' 
; 87: Dim code As Byte
; 88: Read 0, code
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x3E
; 89: 
; 90: End
L0006:	GOTO L0006
; 91: 
; 92: ' 
; 93: clear:
L0001:
; 94: 	att = 0
	BCF 0x35,2
; 95: 	atc = 0
	CLRF 0x3A
; 96: 	apn = 0
	CLRF 0x3F
; 97: 
; 98: 	rat = 0
	BCF 0x35,6
; 99: 	rcnt = 0
	CLRF 0x3B
; 100: 
; 101: 	gat = 0
	BCF 0x35,7
; 102: 	gcnt = 0
	CLRF 0x3C
; 103: 
; 104: 	scnt = 0
	CLRF 0x40
; 105: 	spn = 0
	CLRF 0x41
; 106: 
; 107: 	x = %00000000
	CLRF 0x34
; 108: 	xc = 1
	MOVLW 0x01
	MOVWF 0x37
; 109: 
; 110: 	acs = 0
	BCF 0x35,4
; 111: 	acc = 0
	CLRF 0x42
; 112: 
; 113: 	wcode = 0
	BCF 0x35,5
; 114: 	state = 1
	BSF 0x35,3
; 115: 	each = 0
	CLRF 0x39
; 116: 	strike = 0
	CLRF 0x36
; 117: 	
; 118: Return
	RETURN
; 119: 
; 120: '  (TMR0 
; 121: ' ~ 65 .)
; 122: On Interrupt
L0005:
; 123: 
; 124: '
; 125: If denide Then
	BTFSS 0x3D,0
	GOTO L0007
; 126: 	den_p = den_p + 1
	MOVF 0x44,W
	MOVWF R0L
	MOVF 0x45,W
	MOVWF R0H
	MOVF 0x46,W
	MOVWF R1L
	MOVF 0x47,W
	MOVWF R1H
	MOVLW 0x01
	MOVWF R2L
	CLRF R2H
	CLRF R3L
	CLRF R3H
	CALL LA01
	MOVF R0L,W
	MOVWF 0x44
	MOVF R0H,W
	MOVWF 0x45
	MOVF R1L,W
	MOVWF 0x46
	MOVF R1H,W
	MOVWF 0x47
; 127: 	' 
; 128: 	If den_p = 1000 Then
	MOVF 0x44,W
	MOVWF R0L
	MOVF 0x45,W
	MOVWF R0H
	MOVF 0x46,W
	MOVWF R1L
	MOVF 0x47,W
	MOVWF R1H
	MOVLW 0xE8
	MOVWF R2L
	MOVLW 0x03
	MOVWF R2H
	CLRF R3L
	CLRF R3H
	CALL CL01
	BTFSS STATUS,Z
	GOTO L0008
; 129: 		denide = 0
	BCF 0x3D,0
; 130: 		den_p = 0
	CLRF 0x44
	CLRF 0x45
	CLRF 0x46
	CLRF 0x47
; 131: 		den_c = 0
	CLRF 0x38
; 132: 		Low PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BCF PORTC,0
; 133: 		Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 134: 		Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 135: 		Gosub clear
	CALL L0001
; 136: 	Endif
L0008:
; 137: 	Goto skip
	GOTO L0003
; 138: Endif
L0007:
; 139: 
; 140: ' 
; 141: If change Then
	BTFSS 0x35,0
	GOTO L0009
; 142: 
; 143: 	' 
; 144: 	If state Then
	BTFSS 0x35,3
	GOTO L0010
; 145: 		High PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BSF PORTC,1
; 146: 	Else
	GOTO L0011
L0010:
; 147: 		Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 148: 	Endif
L0011:
; 149: 	
; 150: 	each = each + 1
	MOVF 0x39,W
	ADDLW 0x01
	MOVWF 0x39
; 151: 	If each = 5 Then
	MOVF 0x39,W
	SUBLW 0x05
	BTFSS STATUS,Z
	GOTO L0012
; 152: 		each = 0
	CLRF 0x39
; 153: 		state = Not state
	MOVLW 0x08
	XORWF 0x35,F
; 154: 		If strike < 9 Then
	MOVLW 0x09
	SUBWF 0x36,W
	BTFSC STATUS,C
	GOTO L0013
; 155: 			strike = strike + 1
	MOVF 0x36,W
	ADDLW 0x01
	MOVWF 0x36
; 156: 		Endif
L0013:
; 157: 	Endif
L0012:
; 158: 
; 159: 	If strike < 9 Then
	MOVLW 0x09
	SUBWF 0x36,W
	BTFSC STATUS,C
	GOTO L0014
; 160: 		High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 161: 		Goto skip
	GOTO L0003
; 162: 	Endif
L0014:
; 163: 	
; 164: 	att = 1
	BSF 0x35,2
; 165: 	Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 166: 	Goto adapt
	GOTO L0002
; 167: Endif
L0009:
; 168: 
; 169: '    
; 170: If acs Then
	BTFSS 0x35,4
	GOTO L0015
; 171: 
; 172: 	s = PORTC.5 And PORTC.4
	CLRW
	BTFSS 0x07,5
	ADDLW 0x01
	BTFSS 0x07,4
	ADDLW 0x01
	BTFSC STATUS,Z
	BSF 0x3D,1
	BTFSS STATUS,Z
	BCF 0x3D,1
; 173: 
; 174: 	If s Then
	BTFSS 0x3D,1
	GOTO L0016
; 175: 		change = 1
	BSF 0x35,0
; 176: 		fs = 0
	BCF 0x35,1
; 177: 		strike = 0
	CLRF 0x36
; 178: 		Gosub clear
	CALL L0001
; 179: 		Goto skip
	GOTO L0003
; 180: 	Endif
L0016:
; 181: 
; 182: 	High PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BSF PORTC,1
; 183: 	High PORTC.3
	BSF STATUS,RP0
	BCF TRISC,3
	BCF STATUS,RP0
	BSF PORTC,3
; 184: 	
; 185: 	acc = acc + 1
	MOVF 0x42,W
	ADDLW 0x01
	MOVWF 0x42
; 186: 		' 15 
; 187: 		If acc = 225 Then
	MOVF 0x42,W
	SUBLW 0xE1
	BTFSS STATUS,Z
	GOTO L0017
; 188: 			Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 189: 			Low PORTC.3
	BSF STATUS,RP0
	BCF TRISC,3
	BCF STATUS,RP0
	BCF PORTC,3
; 190: 			Gosub clear
	CALL L0001
; 191: 		Endif
L0017:
; 192: 	Goto skip
	GOTO L0003
; 193: Endif
L0015:
; 194: 
; 195: '  
; 196: If wcode Then
	BTFSS 0x35,5
	GOTO L0018
; 197: 
; 198: 	' 
; 199: 	If state Then
	BTFSS 0x35,3
	GOTO L0019
; 200: 		High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 201: 	Else
	GOTO L0020
L0019:
; 202: 		Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 203: 	Endif
L0020:
; 204: 	
; 205: 	each = each + 1
	MOVF 0x39,W
	ADDLW 0x01
	MOVWF 0x39
; 206: 	If each = 5 Then
	MOVF 0x39,W
	SUBLW 0x05
	BTFSS STATUS,Z
	GOTO L0021
; 207: 		each = 0
	CLRF 0x39
; 208: 		state = Not state
	MOVLW 0x08
	XORWF 0x35,F
; 209: 		strike = strike + 1
	MOVF 0x36,W
	ADDLW 0x01
	MOVWF 0x36
; 210: 	Endif
L0021:
; 211: 	
; 212: 	If strike = 25 Then
	MOVF 0x36,W
	SUBLW 0x19
	BTFSS STATUS,Z
	GOTO L0022
; 213: 		Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 214: 		Gosub clear
	CALL L0001
; 215: 	Endif
L0022:
; 216: 		
; 217: 	Goto skip
	GOTO L0003
; 218: Endif
L0018:
; 219: 
; 220: adapt:
L0002:
; 221: 
; 222: '  
; 223: If att Then
	BTFSS 0x35,2
	GOTO L0023
; 224: 	'   4 .
; 225: 	If atc > 60 Then
	MOVF 0x3A,W
	SUBLW 0x3C
	BTFSC STATUS,C
	GOTO L0024
; 226: 		Low PORTC.3
	BSF STATUS,RP0
	BCF TRISC,3
	BCF STATUS,RP0
	BCF PORTC,3
; 227: 		Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 228: 		
; 229: 		If change Then
	BTFSS 0x35,0
	GOTO L0025
; 230: 			fs = 0
	BCF 0x35,1
; 231: 			change = 0
	BCF 0x35,0
; 232: 		Endif
L0025:
; 233: 		
; 234: 		apn = apn + 1
	MOVF 0x3F,W
	ADDLW 0x01
	MOVWF 0x3F
; 235: 		Low PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BCF PORTC,0
; 236: 		High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 237: 		'  3 .
; 238: 		If apn < 45 Then
	MOVLW 0x2D
	SUBWF 0x3F,W
	BTFSC STATUS,C
	GOTO L0026
; 239: 			Goto skip
	GOTO L0003
; 240: 		Endif
L0026:
; 241: 		Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 242: 		
; 243: 		Gosub clear
	CALL L0001
; 244: 		
; 245: 	Else
	GOTO L0027
L0024:
; 246: 		atc = atc + 1
	MOVF 0x3A,W
	ADDLW 0x01
	MOVWF 0x3A
; 247: 	Endif
L0027:
; 248: Endif
L0023:
; 249: 
; 250: '   
; 251: If rcnt >= gcnt Then
	MOVF 0x3C,W
	SUBWF 0x3B,W
	BTFSS STATUS,C
	GOTO L0028
; 252: 	scnt = rcnt
	MOVF 0x3B,W
	MOVWF 0x40
; 253: Else
	GOTO L0029
L0028:
; 254: 	scnt = gcnt
	MOVF 0x3C,W
	MOVWF 0x40
; 255: Endif
L0029:
; 256: 
; 257: '   3.
; 258: If scnt > 45 Then
	MOVF 0x40,W
	SUBLW 0x2D
	BTFSC STATUS,C
	GOTO L0030
; 259: 
; 260: 	Low PORTC.3
	BSF STATUS,RP0
	BCF TRISC,3
	BCF STATUS,RP0
	BCF PORTC,3
; 261: 	Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 262: 
; 263: 	If change Then
	BTFSS 0x35,0
	GOTO L0031
; 264: 		fs = 0
	BCF 0x35,1
; 265: 		change = 0
	BCF 0x35,0
; 266: 	Endif
L0031:
; 267: 
; 268: 	spn = spn + 1
	MOVF 0x41,W
	ADDLW 0x01
	MOVWF 0x41
; 269: 	Low PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BCF PORTC,0
; 270: 	High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 271: 	'  3 .
; 272: 	If spn < 45 Then
	MOVLW 0x2D
	SUBWF 0x41,W
	BTFSC STATUS,C
	GOTO L0032
; 273: 		Goto skip
	GOTO L0003
; 274: 	Endif
L0032:
; 275: 	Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 276: 
; 277: 	Gosub clear
	CALL L0001
; 278: 	
; 279: Endif
L0030:
; 280: 	'  
; 281: 	If PORTC.5 Then
	BTFSS 0x07,5
	GOTO L0033
; 282: 		
; 283: 		If PORTC.4 Then
	BTFSS 0x07,4
	GOTO L0034
; 284: 			High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 285: 
; 286: 			If change Then
	BTFSS 0x35,0
	GOTO L0035
; 287: 				fs = 0
	BCF 0x35,1
; 288: 				change = 0
	BCF 0x35,0
; 289: 			Endif
L0035:
; 290: 			
; 291: 			Gosub clear
	CALL L0001
; 292: 			Goto skip
	GOTO L0003
; 293: 		Endif
L0034:
; 294: 		Low PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BCF PORTC,2
; 295: 		
; 296: 		High PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BSF PORTC,0
; 297: 		att = 0
	BCF 0x35,2
; 298: 		'  
; 299: 		' 
; 300: 		If rat Then
	BTFSS 0x35,6
	GOTO L0036
; 301: 			rcnt = rcnt + 1
	MOVF 0x3B,W
	ADDLW 0x01
	MOVWF 0x3B
; 302: 		Endif
L0036:
; 303: 		rat = 1
	BSF 0x35,6
; 304: 	Else
	GOTO L0037
L0033:
; 305: 		rcnt = 0
	CLRF 0x3B
; 306: 		'  
; 307: 		If rat Then
	BTFSS 0x35,6
	GOTO L0038
; 308: 			att = 1
	BSF 0x35,2
; 309: 			atc = 0
	CLRF 0x3A
; 310: 			rat = 0
	BCF 0x35,6
; 311: 			x = x + xc
	MOVF 0x34,W
	ADDWF 0x37,W
	MOVWF 0x34
; 312: 			If xc = 128 Then
	MOVF 0x37,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0039
; 313: 				'   
; 314: 				If change Then
	BTFSS 0x35,0
	GOTO L0040
; 315: 					If Not fs Then
	BTFSC 0x35,1
	GOTO L0041
; 316: 						first = x
	MOVF 0x34,W
	MOVWF 0x43
; 317: 						fs = 1
	BSF 0x35,1
; 318: 						strike = 0
	CLRF 0x36
; 319: 						x = %00000000
	CLRF 0x34
; 320: 						xc = 1
	MOVLW 0x01
	MOVWF 0x37
; 321: 					Else
	GOTO L0042
L0041:
; 322: 						fs = 0
	BCF 0x35,1
; 323: 						If x <> first Then
	MOVF 0x34,W
	SUBWF 0x43,W
	BTFSC STATUS,Z
	GOTO L0043
; 324: 							change = 0
	BCF 0x35,0
; 325: 							Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 326: 							Low PORTC.3
	BSF STATUS,RP0
	BCF TRISC,3
	BCF STATUS,RP0
	BCF PORTC,3
; 327: 							wcode = 1
	BSF 0x35,5
; 328: 						Else
	GOTO L0044
L0043:
; 329: 							code = x
	MOVF 0x34,W
	MOVWF 0x3E
; 330: 							Write 0, x
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x34,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0045:	BTFSC EECON1,WR
	GOTO L0045
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 331: 							change = 0
	BCF 0x35,0
; 332: 							acs = 1
	BSF 0x35,4
; 333: 						Endif
L0044:
; 334: 					Endif
L0042:
; 335: 				Else
	GOTO L0046
L0040:
; 336: 					'  
; 337: 					If x = code Then
	MOVF 0x34,W
	SUBWF 0x3E,W
	BTFSS STATUS,Z
	GOTO L0047
; 338: 						acs = 1
	BSF 0x35,4
; 339: 						den_c = 0
	CLRF 0x38
; 340: 					Else
	GOTO L0048
L0047:
; 341: 						wcode = 1
	BSF 0x35,5
; 342: 						den_c = den_c + 1
	MOVF 0x38,W
	ADDLW 0x01
	MOVWF 0x38
; 343: 						If den_c = 3 Then
	MOVF 0x38,W
	SUBLW 0x03
	BTFSS STATUS,Z
	GOTO L0049
; 344: 							denide = 1
	BSF 0x3D,0
; 345: 							High PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BSF PORTC,0
; 346: 							High PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BSF PORTC,1
; 347: 							High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 348: 							Goto skip
	GOTO L0003
; 349: 						Endif
L0049:
; 350: 					Endif
L0048:
; 351: 				Endif
L0046:
; 352: 			
; 353: 			Else
	GOTO L0050
L0039:
; 354: 				xc = xc * 2
	MOVF 0x37,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x02
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x37
; 355: 			Endif
L0050:
; 356: 		Endif
L0038:
; 357: 				
; 358: 		'  
; 359: 		If PORTC.4 Then
	BTFSS 0x07,4
	GOTO L0051
; 360: 			High PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BSF PORTC,0
; 361: 			att = 0
	BCF 0x35,2
; 362: 			'  
; 363: 			' 
; 364: 			If gat Then
	BTFSS 0x35,7
	GOTO L0052
; 365: 				gcnt = gcnt + 1
	MOVF 0x3C,W
	ADDLW 0x01
	MOVWF 0x3C
; 366: 			Endif
L0052:
; 367: 			gat = 1
	BSF 0x35,7
; 368: 		Else
	GOTO L0053
L0051:
; 369: 			gcnt = 0
	CLRF 0x3C
; 370: 			'  
; 371: 			If gat Then
	BTFSS 0x35,7
	GOTO L0054
; 372: 				att = 1
	BSF 0x35,2
; 373: 				atc = 0
	CLRF 0x3A
; 374: 				gat = 0
	BCF 0x35,7
; 375: 				If xc = 128 Then
	MOVF 0x37,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0055
; 376: 					'   
; 377: 					If change Then
	BTFSS 0x35,0
	GOTO L0056
; 378: 						If Not fs Then
	BTFSC 0x35,1
	GOTO L0057
; 379: 							fs = 1
	BSF 0x35,1
; 380: 							first = x
	MOVF 0x34,W
	MOVWF 0x43
; 381: 							strike = 0
	CLRF 0x36
; 382: 							x = %00000000
	CLRF 0x34
; 383: 							xc = 1
	MOVLW 0x01
	MOVWF 0x37
; 384: 						Else
	GOTO L0058
L0057:
; 385: 							fs = 0
	BCF 0x35,1
; 386: 							If x <> first Then
	MOVF 0x34,W
	SUBWF 0x43,W
	BTFSC STATUS,Z
	GOTO L0059
; 387: 								change = 0
	BCF 0x35,0
; 388: 								Low PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BCF PORTC,1
; 389: 								Low PORTC.3
	BSF STATUS,RP0
	BCF TRISC,3
	BCF STATUS,RP0
	BCF PORTC,3
; 390: 								wcode = 1
	BSF 0x35,5
; 391: 							Else
	GOTO L0060
L0059:
; 392: 								code = x
	MOVF 0x34,W
	MOVWF 0x3E
; 393: 								Write 0, x
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x34,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0061:	BTFSC EECON1,WR
	GOTO L0061
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 394: 								change = 0
	BCF 0x35,0
; 395: 								acs = 1
	BSF 0x35,4
; 396: 							Endif
L0060:
; 397: 						Endif
L0058:
; 398: 					Else
	GOTO L0062
L0056:
; 399: 						'  
; 400: 						If x = code Then
	MOVF 0x34,W
	SUBWF 0x3E,W
	BTFSS STATUS,Z
	GOTO L0063
; 401: 							acs = 1
	BSF 0x35,4
; 402: 							den_c = 0
	CLRF 0x38
; 403: 						Else
	GOTO L0064
L0063:
; 404: 							wcode = 1
	BSF 0x35,5
; 405: 							den_c = den_c + 1
	MOVF 0x38,W
	ADDLW 0x01
	MOVWF 0x38
; 406: 							If den_c = 3 Then
	MOVF 0x38,W
	SUBLW 0x03
	BTFSS STATUS,Z
	GOTO L0065
; 407: 								denide = 1
	BSF 0x3D,0
; 408: 								High PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BSF PORTC,0
; 409: 								High PORTC.1
	BSF STATUS,RP0
	BCF TRISC,1
	BCF STATUS,RP0
	BSF PORTC,1
; 410: 								High PORTC.2
	BSF STATUS,RP0
	BCF TRISC,2
	BCF STATUS,RP0
	BSF PORTC,2
; 411: 								Goto skip
	GOTO L0003
; 412: 							Endif
L0065:
; 413: 						Endif
L0064:
; 414: 					Endif
L0062:
; 415: 				Else
	GOTO L0066
L0055:
; 416: 					xc = xc * 2
	MOVF 0x37,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x02
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x37
; 417: 				Endif
L0066:
; 418: 			Endif
L0054:
; 419: 			
; 420: 			Low PORTC.0
	BSF STATUS,RP0
	BCF TRISC,0
	BCF STATUS,RP0
	BCF PORTC,0
; 421: 		Endif
L0053:
; 422: 		
; 423: 	Endif
L0037:
; 424: 
; 425: skip:
L0003:
; 426: INTCON.T0IF = 0
	BCF 0x0B,2
; 427: '  
; 428: Resume
	RETURN
; End of program
L0067:	GOTO L0067
; Word Multiplication Routine
M001:	MOVLW 0x10
	MOVWF R4L
	CLRF R0H
	CLRF R0L
M002:	RRF R3H,F
	RRF R3L,F
	BTFSS STATUS,C
	GOTO M003
	MOVF R1L,W
	ADDWF R0L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R0H,F
M003:	RRF R0H,F
	RRF R0L,F
	RRF R2H,F
	RRF R2L,F
	DECFSZ R4L,F
	GOTO M002
	RETURN
; Long Addition Routine
LA01:	MOVF R2L,W
	ADDWF R0L,F
	BTFSC STATUS,C
	CALL LA02
	MOVF R2H,W
	ADDWF R0H,F
	BTFSC STATUS,C
	CALL LA03
	MOVF R3L,W
	ADDWF R1L,F
	BTFSC STATUS,C
	CALL LA04
	MOVF R3H,W
	ADDWF R1H,F
	RETURN
LA02:	INCF R0H,F
	BTFSS STATUS,Z
	RETURN
LA03:	INCF R1L,F
	BTFSS STATUS,Z
	RETURN
LA04:	INCF R1H,F
	RETURN
; Long Comparison Routine
CL01:	MOVF R3H,W
	SUBWF R1H,W
	BTFSS STATUS,Z
	GOTO CL02
	MOVF R3L,W
	SUBWF R1L,W
	BTFSS STATUS,Z
	GOTO CL02
	MOVF R2H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO CL02
	MOVF R2L,W
	SUBWF R0L,W
CL02:	RETURN
CL03:	MOVF R1H,W
	SUBWF R3H,W
	BTFSS STATUS,Z
	GOTO CL04
	MOVF R1L,W
	SUBWF R3L,W
	BTFSS STATUS,Z
	GOTO CL04
	MOVF R0H,W
	SUBWF R2H,W
	BTFSS STATUS,Z
	GOTO CL04
	MOVF R0L,W
	SUBWF R2L,W
CL04:	RETURN
; End of listing
	END
